import Allegory.Alleg.Database;
import Allegory.Alleg.Dept;
import Allegory.Alleg.DeptTable;
import MDLUtilities.Marquee1In_0Out;
import java.io.PrintStream;

public class GroupByTests {
    static PrintStream outt; 
    
    public static void main(String... args) throws Exception {
        String[] args1 = { "x.alleg.pl" }; // override args with args1
        
        // Standard marquee processing
        Marquee1In_0Out mark = new Marquee1In_0Out(Driver.class, ".alleg.pl", args1);
        String inputFileName = mark.getInputFileName();
        Database db = new Database(inputFileName);
        outt = System.out;
        
        outt.println();
        outt.println("group by city\n");
        db.Dept.groupBy(t -> t.city, tbl -> display(tbl));
        
        outt.println();
        outt.println("group by city\n");
        db.Dept.groupBy(t -> t.city, tbl -> display2(tbl));
    }
    
    public static void display(DeptTable t) {
        Dept d = t.getFirst();
        outt.format("%10s group\n", d.city);
        t.print(outt);
    }
    
    public static void display2(DeptTable t) {
        Dept d = t.getFirst();
        outt.format("%10s has %d Dept(s)\n", d.city, t.size());
    }
}
